require "Scripts/timer.lua";

-- In our App.loop we must allow the timers to think.
-- Add this somwhere in App.loop.
timer.__think();

-- Simple timer, only runs once.
timer.Simple(5, print, "This will only run once.");
-- Same timer, different way of adding the function.
timer.Simple(5, function()
	print("This will only run once.");
end);
-- Again, same timer, but with more arguments to the function.
local Delay = 5;
timer.Simple(Delay, print, "This timer ran after a delay of", Delay, "seconds.");


-- timer.Create creates a timer with repetitions, if the repetition count is set to 0 it will keep running.
-- Let's create a timer with a .5s delay that runs 10 times.
timer.Create(0.5, 10, "unique_timer_name", print, "Our timer is running!");

-- Now let's create one that runs infinitely.
timer.Create(0.5, 0, "new_timer_name", print, "This will get annoying wont it?");
-- we can pause it.
timer.Pause("new_timer_name");
-- and we can continue it.
timer.Continue("new_timer_name");
-- we can also remove it.
timer.Remove("new_timer_name");